Quassel IRC - Bug #1170

Cannot migrate 0.8.0 to PostgreSQL
05/30/2012 08:52 PM - miohtama

Status: New Start date: 05/30/2012
Priority: Low Due date:

Assignee: % Done: 0%
Category: Estimated time: 0.00 hour
Target version:

Version: 0.8-pre 0S: Any
Description

| tried to migrate my SQLite to PostgreSQL and it failed
2012-05-30 21:43:26 Info: PostgreSQL Storage Backend is ready. Quassel Schema Version: 16
Switched backend to: PostgreSQL
Migrating Storage backend SQLite to PostgreSQL...
Transferring QuasselUser...
Done.
Transferring Identity...
Done.
Transferring IdentityNick...
Done.
Transferring Network...
Done.
Transferring Buffer...
Migration Failed!
AbstractSglMigrationReader::transferMo () : unable to transfer Migratable Object of type Buffer!
WriterError:
executed Query:
INSERT INTO buffer (bufferid, userid, groupid, networkid, buffername, buffercname, buffertype, las
tseenmsgid, markerlinemsgid, key, joined)
VALUES (2?2, 2, 2, 2, 2, 2, 2, 2, 2, 2?2, ?)
bound Values:
22
1
0
2
#xxx
#xxx
0 : true

Error Number: -1

Error Message: "ERROR: insert or update on table "buffer" violates foreign key constraint "buff
er_networkid_fkey"

DETAIL: Key (networkid)=(2) is not present in table "network".

QPSQL: Unable to create query"

Possible causes of failure:

- Database is not fresh, but has had prior Quassel installation before. | dropped all tables before trying to migrate, but is there
something else to drop

- The data is really old from 0.6 version and maybe below. It might not be sane in modern standards.

History

#1 - 08/25/2012 05:20 PM - dxbi

Had the same problem on a new psql database. Turned out to be a single message from an abandoned buffer:

sglite> select networkid from buffer where networkid not in (select networkid from network group by networkid)

’
networkid

8

sqlite> select * from buffer where networkid=8;
bufferid|userid|groupid|networkid|buffername|buffercname|buffertype|lastseenmsgid|key|joined|markerlinemsgid
1871111811111011010

sqglite> select * from backlog where bufferid=187;

messageid|time|bufferid|typelflags|senderid|message

14170521128941950011871024|0|1|Disconnecting. (http://quassel-irc.org — Chat comfortably. Anywhere.)

Deleting the offending rows fixed the issue. Wouldn't it make sense to do this automatically? Buffers connected to deleted networks can't be accessed
anyway, right?

sglite> delete from backlog where bufferid=187;

sqlite> delete from buffer where networkid=8;

Also, after the failed migration attempt, | had to restore quasselCore.conf from backup because the storage backend had already been updated

and the migration would always fail with

Switched backend to: PostgreSQL

No currently active backend. Skipping migration.
New backend does not support migration: PostgreSQL
Add a new user:

Username:

#2 - 10/09/2014 07:08 PM - Bombe

It is also possible to simply switch back to the SQLite backend using

quasselcore --select-backend=sqglite

As the sqlite database already exists nothing is changed except for the configuration.

05/24/2025 3/3


http://www.tcpdf.org

